/**

 * Redistribution and use of this software and associated documentation

 * ("Software"), with or without modification, are permitted provided

 * that the following conditions are met:

 *

 * 1. Redistributions of source code must retain copyright

 *    statements and notices.  Redistributions must also contain a

 *    copy of this document.

 *

 * 2. Redistributions in binary form must reproduce the

 *    above copyright notice, this list of conditions and the

 *    following disclaimer in the documentation and/or other

 *    materials provided with the distribution.

 *

 * 3. The name "Exolab" must not be used to endorse or promote

 *    products derived from this Software without prior written

 *    permission of Exoffice Technologies.  For written permission,

 *    please contact info@exolab.org.

 *

 * 4. Products derived from this Software may not be called "Exolab"

 *    nor may "Exolab" appear in their names without prior written

 *    permission of Exoffice Technologies. Exolab is a registered

 *    trademark of Exoffice Technologies.

 *

 * 5. Due credit should be given to the Exolab Project

 *    (http://www.exolab.org/).

 *

 * THIS SOFTWARE IS PROVIDED BY EXOFFICE TECHNOLOGIES AND CONTRIBUTORS

 * ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT

 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND

 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL

 * EXOFFICE TECHNOLOGIES OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT,

 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES

 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR

 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)

 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,

 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)

 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED

 * OF THE POSSIBILITY OF SUCH DAMAGE.

 *

 * Copyright 1999 (C) Exoffice Technologies Inc. All Rights Reserved.

 *

 * $Id: NamingException.java,v 1.1 2002/03/23 06:30:27 gudujarlson Exp $

 */

package org.openejb.core.ivm.naming;



/**

 * Derivative of javax.naming.NamingException that delegates to org.openejb.OpenEJBException.

 * This allows us to propogate "root cause" information to clients of javax.naming.

 */

public class NamingException extends javax.naming.NamingException {

    private org.openejb.OpenEJBException delegate;

    public NamingException( String message, org.openejb.OpenEJBException delegateArg) {

	super();

	delegate = delegateArg;

    }

    public NamingException( String message, Throwable rootCause) {

	super();

	delegate = new org.openejb.OpenEJBException( message, rootCause);

    }

    public String getMessage() {

	return delegate.getMessage();

    }

    public void printStackTrace() {

	delegate.printStackTrace();

    }

    public void printStackTrace( java.io.PrintStream stream) {

        delegate.printStackTrace(stream);

    }

    public void printStackTrace( java.io.PrintWriter writer) {

        delegate.printStackTrace(writer);

    }

}

